package com.autentia.tutoriales.spring.aop.aspectj.cache;

import org.junit.Assert;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import com.autentia.tutoriales.spring.aop.aspectj.Provincias;

/**
 * Lanzo el ejemplo a modo de test funcional..
 * ya se que esto no es un test valido real, sólo lo hago para ahorrarme tiempo 
 */
public class SpringCacheTest  {

	private ApplicationContext  factory;  

	/** 
	 * Inicializamos el contexto de Spring 
	 */  
	@org.junit.Before  
	public void initTests(){  
		this.factory  = new ClassPathXmlApplicationContext("applicationContext.xml");
	}  

	@org.junit.Test
	public void testCache() {
		Provincias provincias;
		java.util.List<String> lista;
		long timestamp = 0;
		
		try {
			provincias = (Provincias) factory.getBean("provincias") ;

			System.err.println("Forzamos descacheo");
			provincias.add("a");
			
			timestamp  = System.currentTimeMillis();			
			lista = provincias.getAll();
			System.err.println("Llamada getAll: " + (System.currentTimeMillis() - timestamp));
			
			timestamp  = System.currentTimeMillis();
			lista = provincias.getAll();
			System.err.println("Llamada getAll: " + (System.currentTimeMillis() - timestamp));

			System.err.println("Forzamos descacheo");
			provincias.add("b");
			
			timestamp  = System.currentTimeMillis();
			lista = provincias.getAll();
			System.err.println("Llamada getAll: " + (System.currentTimeMillis() - timestamp));
			
			System.err.println("FIN");
			
			Assert.assertTrue(true);
		} catch (Exception ex){
			System.err.println(ex);
			Assert.fail();
		}
	}
}
